%------------------------------------------------------------------------------
% abstract.tex - provides an overview over the project in English and German
%------------------------------------------------------------------------------
% author : Manuel Bentele
% date   : 11.12.2016
% project: Student research for the SeeSat project: Middleware 2016/2017
%------------------------------------------------------------------------------

\section*{Abstract}
\addcontentsline{toc}{section}{Abstract}
Just like people, different software \glspl{app} should also be able to
communicate with each other in a spacecraft to solve large and complex
jobs in partial tasks.
\par
This work is based on the development and design of a middleware for the
satellite of the SeeSat project. The middleware should offer and provide a
communication between the apps. In addition to that, the middleware provides
the functionality of the \gls{rtos} in an abstract way and allows access to
hardware devices like sensors and actuators.
\par
In this thesis, in addition to the different types of middleware, the communication
between the \glspl{app} playes a major role.
Beside the net topology and form of communication, there will be an easy and
expandable communication protocol for the middleware specified. The middleware
also supports the technology of Time and Space Partitioning to minimize the risks
in security critical software and ensuring a high system stability.
These aspects are used to design the software architecture of the middleware.
\par
The result of this work is the specification of the middleware interfaces using
an extensively documented software \gls{api} created in the programming
language~C.
In addition, the result also provides details for a software architecture,
implementation of the middleware, communication and and all other relevant
aspects.

\clearpage

\section*{Kurzfassung}
\addcontentsline{toc}{section}{Kurzfassung}
Ebenso wie Menschen sollten auch verschiedene Software \glspl{app} innerhalb eines Raumfahrtzeugs miteinander kommunizieren können, um die großen und komplexen Aufgaben gemeinsam in Teilaufgaben lösen zu können.
\par
Diese Arbeit verfolgt als Hauptziel die Entwicklung und Konzeption einer Middleware für den Satelliten des SeeSat Projektes. Mit Hilfe der Middleware soll eine Kommunikation zwischen den \glspl{app} ermöglicht und bereitstellt werden. Zudem stellt die Middleware die Funktionalität des \gls{rtos} abstrahiert bereit und bietet Zugriff auf Hardwaregeräte in Form von Sensoren und Aktoren.
\par
In dieser Arbeit wird neben den verschiedenen Typen von Middleware auch speziell auf die Kommunikation zwischen den \glspl{app} eingegangen. Neben der Netztopologie und Form der Kommunikation wird ein leichtes und erweiterbares Kommunikationsprotokoll für die Middleware spezifiziert. Die Middleware unterstützt zudem die Technologie Time and Space Partitioning, um die Risiken in sicherheitskritischer Software zu minimieren und somit eine hohe Ausfallsicherheit zu garantieren. Anhand dieser Aspekte folgt ein Entwurf für die Softwarearchitektur der Middleware.
\par
Das Ergebnis dieser Arbeit stellt die Spezifizierung der Middleware"=Schnittstellen in Form einer umfangreich dokumentierten Software"=\gls{api} in der Programmiersprache~C dar. Zudem wird in dieser Arbeit die zukünftige Softwarearchitektur und Implementation der Middleware, die Kommunikation samt Kommunikationsprotokoll und alle weiteren relevanten Aspekte beschrieben und erläutert.
